{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG } {$R+,S+ } {$ELSE } {$D-,L-,R-,S- } {$ENDIF }

{$M $4000, 0, 655360 }

Program V;

Uses Dos,Crt;

Const INTVIDEO = $10;

      SizeX    = 320;
      SizeY    = 200;

Var LastVideoMode : Byte;
    video_x       : Word;
    video_y       : Word;

Procedure OpenVideo;
Var Reg : Registers;
Begin
 Reg.AH := $0F;
 Intr(INTVIDEO,Reg);
 LastVideoMode := Reg.AL;

 Reg.AH := $00;
 Reg.AL := $13;  { 320x200x256 }
 Intr(INTVIDEO,Reg);
End;


Procedure CloseVideo;
Var Reg : Registers;
Begin
 Reg.AH := $00;
 Reg.AL := LastVideoMode;
 Intr(INTVIDEO,Reg);
End;


Procedure ShowPixel( x, y : Word; Color : Byte ); Assembler;
Asm
    MOV  AX, [y]
    MOV  BX, [x]

    XCHG AH, AL
    ADD  BX, AX
    SHR  AX, 1
    SHR  AX, 1
    ADD  BX, AX
    MOV  AX, 0A000h
    MOV  ES, AX

    MOV  AL, [Color]
    MOV  [ES:BX], AL
End;


{ __8C__ }

Const NB_GRAY : Word = 64;

{ __FIN__ }

Const Roto : Array[0..3] Of Char = ('-','\','|','/');

Const
      Default_gX   = 0;
      Default_gY   = 0;
      Default_gLg  = 32767;
      Default_gNb  = 32767;

      Default_mX   = 0;
      Default_mY   = 1;
      Default_mLg  = 40;
      Default_mNb  = 24;

      Default_gBLo  = 0;
      Default_gBHi  = 100;
      Default_gLux  = 0;

      Default_RDX   = 8;
      Default_RDY   = 10;

      gX         : Word    = Default_gX;
      gY         : Word    = Default_gY;
      gLg        : Integer = Default_gLg;
      gNb        : Integer = Default_gNb;

      mX         : Byte    = Default_mX;
      mY         : Byte    = Default_mY;
      mLg        : Byte    = Default_mLg;
      mNb        : Byte    = Default_mNb;

      gBLo       : Integer = Default_gBLo;
      gBHi       : Integer = Default_gBHi;
      gLux       : Integer = Default_gLux;

      RDX        : Byte    = Default_RDX;
      RDY        : Byte    = Default_RDY;


var PCXName     : PathStr;


Function ValStr( x : Longint; lg : Word ) : String;
Var s : String;
Begin
 Str(x:lg,s);
 ValStr := s;
End;



{*********************************
 *                               *
 *           P  C  X             *
 *                               *
 *********************************}

Const LgBufMax = 8192;

      NbPlansMax = 8;

      PPLMax     = 10240;  { pixel par ligne max }

Type
     LongRec = Record
       Lo, Hi : Word;
      End;

     RGB = Record
       Red, Green, Blue : Byte;
      End;

     Pal16 = Array[1..16] Of RGB;

     PCXHeadRec = Record
       Marque   : Byte;
       Version  : Byte;
       Codage   : Byte;
       BPX      : Byte;
       XG       : Word;
       YH       : Word;
       XD       : Word;
       YB       : Word;
       HRes     : Word;
       VRes     : Word;
       Palette  : Pal16;
       Reserve1 : Byte;
       NbPlans  : Byte;
       BPL      : Word;
       Reserve2 : Array[1..60] of Byte;
      End;

     Pal256 = Array[0..255] Of RGB;

     LineVideo = Array[0..PPLMax-1] Of Byte;  { jusqu' 32768 pixels/ligne ! }

     PLineVideo = ^LineVideo;

     MarkerRec = Record
       Buf    : Array[0..LgBufMax-1] Of Byte;  { buffer pour acclerer }
       LgBuf  : Word;         { nombre dans le buffer }
       iRead  : Word;         { position de lecture du buffer }
       CCode  : Byte;         { dernier code lu }
       NbRep  : Byte;         { nombre de repetition sur ce code }
      End;

     LevArray = Array[0..PPLMax-1] Of Longint;
     PLevArray= ^LevArray;

Const Palette16 : Pal16 = (
        ( Red:$00; Green:$00; Blue:$0E ),
        ( Red:$00; Green:$52; Blue:$07 ),
        ( Red:$2C; Green:$00; Blue:$0E ),
        ( Red:$00; Green:$00; Blue:$00 ),
        ( Red:$F8; Green:$01; Blue:$2C ),
        ( Red:$00; Green:$85; Blue:$0F ),
        ( Red:$42; Green:$00; Blue:$21 ),
        ( Red:$00; Green:$00; Blue:$00 ),
        ( Red:$00; Green:$00; Blue:$6A ),
        ( Red:$24; Green:$9B; Blue:$49 ),
        ( Red:$A1; Green:$5E; Blue:$90 ),
        ( Red:$5E; Green:$18; Blue:$5E ),
        ( Red:$84; Green:$14; Blue:$D9 ),
        ( Red:$95; Green:$A0; Blue:$14 ),
        ( Red:$12; Green:$00; Blue:$06 ),
        ( Red:$00; Green:$68; Blue:$1F )
       );


Var f         : File;         { source PCX }
    Head      : PCXHeadRec;   { en-tte }
    LgPal     : Word;         { nombre de couleurs }
    PalBW     : Array[0..255] Of Byte;
    xMax      : Word;
    yMax      : Word;
    xBPL      : Word;
    BPXMask   : Byte;
    BPXOfs    : Byte;
    Mark      : MarkerRec;

    dLg       : Word;
    dNb       : Word;

    gLine     : Word;         { n de la ligne (absolue)  lire }
    glv       : PLineVideo;
    gLev      : PLevArray;
    gResult   : PLineVideo;

    dLv       : Array[1..10+1] Of PLineVideo;

    vir       : Longint;

    rch       : Longint;     { rapport de conversion horizontal }
    rcv1      : Longint;     { rapport de conversion vertical 1 }
    rcv2      : Longint;     { ... 2 }
    rcv3      : Longint;     { et 3 }

    gBLarge   : Integer;

    ScaleRo   : Byte;


Procedure Color2BW( Var p );
Var Pal : Pal256 Absolute p;
    i : Byte;
Begin
 For i := 0 To LgPal-1 Do
  Begin
   PalBW[i] := (76*Word(Pal[i].Red)) Div 255+
               (151*Word(Pal[i].Green)) Div 255+
               (28*Word(Pal[i].Blue)) Div 255;
  End;
End;


Function OpenHeader : Boolean;
Var r       : Word;
    Mark    : Byte;
    i       : Byte;
    Pal     : ^Pal256;
Begin
 Assign(f,PCXName);
 Reset(f,1);
 If IoResult=0 Then
  Begin
   BlockRead(f,Head,sizeof(Head),r);
   If (r=SizeOf(PCXHeadRec)) And (Head.Marque=$0A) Then
    If (Head.Version>=2) Then
     If (Head.Codage=1) Then
      If (Head.BPX In [1,2,4,8]) And (Head.NbPlans In [1,2,4,8]) And
         (Head.BPX*Head.NbPlans<=8) Then
       Begin
        xMax   := (Head.XD-Head.XG)+1;
        yMax   := (Head.YB-Head.YH)+1;

        If (xMax>0) And (yMax>0) And (xMax<=PPLMax) Then
         Begin
          LgPal := 1 Shl (Head.BPX+Head.NbPlans-1);

          If (LgPal<256) And (LgPal In [2,4,16]) Then
           Begin
            If LgPal=2 Then
             Begin  { noir & blanc }
              PalBW[0] := 0;
              PalBW[1] := 255;
              xBPL := Head.BPL*8;
             End
            Else
             If LgPal=4 Then
              Begin
               PalBW[0] := 0;         { noir }
               PalBW[1] := 151;       { Turquoise/Vert }
               PalBW[2] := 76;        { Violet/Rouge }
               PalBW[3] := 255;       { Blanc/Jaune }
               xBPL := Head.BPL*8;
              End
             Else
              Begin
               If Head.Version<5 Then Color2BW(Palette16)
               Else Color2BW(Head.Palette);
               xBPL := Head.BPL*8;
              End;

            OpenHeader := TRUE;
            Exit;
           End
          Else
           If LgPal=256 Then
            Begin { 256 couleurs !!! }
             New(Pal);
             Seek(f,FileSize(f)-(SizeOf(Pal256)+1));
             BlockRead(f,Mark,SizeOf(Mark),r);
             If (r=SizeOf(Mark)) and (Mark=$0C) then
              Begin
               BlockRead(f,Pal^,SizeOf(Pal^),r);

               If r=SizeOf(Pal^) then
                Begin
                 Color2BW(Pal^);

                 Dispose(Pal);

                 xBPL := Head.BPL;

                 OpenHeader := TRUE;
                 Exit;
                End
               Else Writeln('Palette invalide');
              End
             Else Writeln('Palette 256 couleurs non trouve');
            End
           Else Writeln('nombre de couleurs (',LgPal,') non trait');
         End
        Else Writeln('rsolution invalide');
       End
      Else Writeln('organisation d''image non reconnue')
     Else Writeln('type de codage inconnu')
    Else Writeln('version non reconnue')
   Else Writeln('fichier PCX non reconnu');

   Close(f);

  End
 Else Writeln('Ouverture de ''',PCXName,''' impossible');
 OpenHeader := FALSE;
End;


Procedure LoadBuf;
Begin
 BlockRead(f,Mark.Buf,sizeof(Mark.Buf),Mark.LgBuf);
 Mark.iRead := 0;
End;


Function  ReadByte : Byte; Assembler;
Asm
    MOV  AL, [Mark.NbRep]
    OR   AL, AL
    JZ   @ICI
    DEC  AL
    MOV  [Mark.NbRep], AL
    MOV  AL, [Mark.CCode]
    JMP  @EXIT
@ICI:
    MOV  AX, [Mark.iRead]
    CMP  AX, [Mark.LgBuf]
    JB   @OK01
    CALL LoadBuf
@OK01:
    MOV  BX, [Mark.iRead]
    MOV  AL, BYTE [Mark.Buf+BX]
    INC  BX
    MOV  [Mark.iRead], BX

    MOV  AH, AL
    AND  AH, 192
    CMP  AH, 192
    JNZ  @PASREP
    AND  AL, (192 XOR 255)
    JZ   @ICI               { repart car NbRep=0 !!! }
    DEC  AL
    MOV  [Mark.NbRep], AL

    MOV  AX, [Mark.iRead]
    CMP  AX, [Mark.LgBuf]
    JB   @OK02
    CALL LoadBuf
@OK02:
    MOV  BX, [Mark.iRead]
    MOV  AL, BYTE [Mark.Buf+BX]
    INC  BX
    MOV  [Mark.iRead], BX

    MOV  [Mark.CCode], AL
    JMP  @EXIT
@PASREP:
    MOV  [Mark.CCode], AL
    MOV  [Mark.NbRep], 0
@EXIT:
End;


Procedure JumpLV;
Var nX    : Word;
    nPlan : Word;
    iCode : Byte;
Begin
 For nPlan := 1 To Head.NbPlans Do
  Begin
   iCode := 0;
   For nX := 0 To xBPL-1 { xMax-1 } Do
    Begin
     If iCode=0 Then ReadByte;
     Inc(iCode,Head.BPX);
     If iCode=8 Then iCode := 0;
    End;
  End;

End;



Procedure ReadLV; Assembler;
Var nX    : Word;
    nPlan : Byte;
    code  : Byte;
    iCode : Byte;
Asm
    CLD
    MOV  CX, [gLg]
    LES  DI, [glv]
    XOR  AL, AL
    REP  STOSB

    MOV  AX, [gLine]
    CMP  AX, [gNb]
    JB   @START
    JMP  @RIEN

    { ----- }

@START:
    MOV  [nPlan], 0

@BIGLOOP:

    MOV  [iCode], 0

    { ----- }

    MOV  CX, [gX]
    JCXZ @EXIT01
    MOV  AL, [iCode]
    MOV  AH, [Head.BPX]
@BOUCLE01:
    OR   AL, AL
    JNZ  @LA01
    PUSH AX             { sauve }
    PUSH CX
    CALL ReadByte
    MOV  [Code], AL
    POP  CX
    POP  AX
@LA01:
    ADD  AL, AH
    CMP  AL, 8
    JB   @LOOP01
    XOR  AL, AL
@LOOP01:
    LOOP @BOUCLE01
    MOV  [iCode], AL
@EXIT01:

    { ----- }

    MOV  AX, [gLg]
    MOV  [nX], AX
    MOV  DL, [iCode]
    MOV  DH, [Head.BPX]
    LES  DI, [glv]
@BOUCLE02:
    OR   DL, DL
    JNZ  @LA02
    PUSH DX             { sauve }
    PUSH DI
    PUSH ES
    CALL ReadByte
    MOV  [code], AL
    POP  ES             { restore }
    POP  DI
    POP  DX
@LA02:
    MOV  AL, 8
    MOV  AH, DL
    ADD  AH, DH
    SUB  AL, AH

    MOV  CL, AL
    MOV  AL, [code]
    SHR  AL, CL
    AND  AL, [BPXMask]  { b }

    PUSH AX

    MOV  AL, [nPlan]
    MOV  CL, [BPXOfs]
    SHL  AL, CL
    MOV  CL, AL

    POP  AX

    SHL  AL, CL
    OR   BYTE [ES:DI], AL
    INC  DI

    ADD  DL, DH
    CMP  DL, 8
    JB   @LOOP02
    XOR  DL, DL
@LOOP02:
    DEC  [nX]
    JNZ  @BOUCLE02

    MOV  [iCode], DL

    { ------ }

{    MOV  CX, [xMax] }
    MOV  CX, [xBPL]
    SUB  CX, [gLg]
    SUB  CX, [gX]
    JCXZ @EXIT03
    MOV  AL, [iCode]
    MOV  AH, [Head.BPX]
@BOUCLE03:
    OR   AL, AL
    JNZ  @LA03
    PUSH AX             { sauve }
    PUSH CX
    CALL ReadByte
    MOV  [Code], AL
    POP  CX
    POP  AX
@LA03:
    ADD  AL, AH
    CMP  AL, 8
    JB   @LOOP03
    XOR  AL, AL
@LOOP03:
    LOOP @BOUCLE03
    MOV  [iCode], AL
@EXIT03:

    MOV  AL, [nPlan]
    INC  AL
    MOV  [nPlan], AL
    CMP  AL, [Head.NbPlans]
    JB   @BIGLOOP

    CMP  [Mark.NbRep], 0
    JE   @RIEN

    MOV  AL, [Mark.NbRep]
    MOV  [Mark.NbRep], AL
(*
    MOV  [Mark.NbRep], 0       { Remettre  Zro pour tre compatible }
                               { avec des bogues de certains fichiers PCX }
*)
    { ------ }

@RIEN:
    CLD
    MOV  CX, [gLg]
    LES  DI, [glv]
    MOV  BX, OFFSET PalBW
@BOUCLE04:
    MOV  AL, [ES:DI]
    XLAT
    STOSB
    LOOP @BOUCLE04


    Inc  [gLine];
End;




Procedure ReadStart;
Var li  : Word;
    ro  : Byte;
Begin
 { recherche le debut  convertir }

 Seek(f,SizeOf(Head));

 FillChar(Mark,SizeOf(Mark),0);

 If gY>0 Then
  Begin
   Write('Recherche du dbut de l''image ...  ');
   ro := 0;

   { on saute ce qui est exclu de l'image }

   li := 0;

   While (li<gY) Do
    Begin         { saute }
     JumpLV;
     If li Mod 32=0 Then
      Begin
       Write(#8+Roto[ro]);
       Inc(ro);
       If ro>=4 Then ro := 0;
      End;
     Inc(li);
    End;

   Writeln;
  End;

End;


Procedure ReadInit;
Begin
 gBLo := (Longint(gBLo)*255) Div 100;
 gBHi := (Longint(gBHi)*255) Div 100;

 gBLarge := gBHi-gBLo;

 If gBLarge=0 Then
  Begin  { corrige la largeur de bande }
   gBLarge := 1;
   Inc(gBHi);
  End;

 BPXMask  := (1 Shl (Head.BPX))-1;
 BPXOfs   := Head.BPX Div 2;

 If gX>=xMax Then gX := xMax-1;
 If gY>=yMax Then gY := yMax-1;
 If gLg<0 Then gLg := xMax+gLg-gX;
 If gNb<0 Then gNb := yMax+gNb-gY;
 If gLg<0 Then gLg := 1
 Else If gLg>=xMax Then gLg := xMax;
 If gNb<0 Then gNb := 1
 Else If gNb>=yMax Then gNb := yMax;
 If gX+gLg>=xMax Then gLg := xMax-gX;
 If gY+gNb>=yMax Then gNb := yMax-gY;

 gLine := 0;

 vir := 0;

 GetMem(glv,SizeOf(glv^[0])*gLg);
 GetMem(gLev,SizeOf(gLev^[0])*gLg);
 GetMem(gResult,SizeOf(gResult^[0])*gLg);

 If mX>=40 then mX := 0;
 If mY>=25 then mY := 0;
 If mLg=0 Then mLg := 1;
 If mNb=0 Then mNb := 1;

 ScaleRo := 0;
End;





Procedure ScaleLV( Var src : LineVideo; Var dst : LineVideo; rch : Longint );
Var ir   : Longint;
    i    : Word;
    lev  : Longint;
    lu   : Longint;
    cqr  : Longint;
Begin
 ir := 0;

 For i := 0 To dLg-1 Do
  Begin
   lev := 0;
   lu  := 0;

   Repeat

    If LongRec(ir).Lo<>0 Then cqr := 65536-LongRec(ir).Lo
    Else
     If rch<=65536 Then cqr := rch
     Else cqr := 65536;

    If lu+cqr>rch Then cqr := rch-lu;

    Inc(lev,(Longint(src[LongRec(ir).Hi]))*cqr);
    Inc(lu,cqr);
    Inc(ir,cqr);

   Until lu>=rch;

   dst[i] := lev Div lu;
  End;
End;



Procedure ScaleReadLV( rcv : Longint );
Var lu  : Longint;
    cqr : Longint;
    i   : Word;
Begin
(*
 Write(#8,Roto[ScaleRo]);
 Inc(ScaleRo);
 If ScaleRo>=4 Then ScaleRo := 0;
*)

 Asm
     CLD
     MOV  CX, [gLg]
     SHL  CX, 1
     LES  DI, [gLev]
     XOR  AX, AX
     REP  STOSW
 End;


 lu := 0;

 Repeat
  If LongRec(vir).Hi=gLine Then ReadLV;

  If LongRec(vir).Lo<>0 Then cqr := 65536-LongRec(vir).Lo
  Else
   If rcv<=65536 Then cqr := rcv
   Else cqr := 65536;

  If lu+cqr>rcv Then cqr := rcv-lu;

  Asm
      MOV  AX, [gLg]
      MOV  [i], AX

      PUSH DS

      LES  DI, [glev]
      LDS  SI, [glv]

  @BOUCLE:
      MOV  AL, [SI]
      XOR  AH, AH
      XOR  DX, DX
      MOV  CX, WORD [cqr]
      MOV  BX, WORD [cqr+2]

      PUSH SI
      PUSH DI

      MOV  SI, AX
      MOV  DI, DX
      MUL  CX
      PUSH AX
      PUSH DX
      MOV  AX, SI
      MUL  BX
      MOV  BX, AX
      MOV  AX, DI
      MUL  CX
      MOV  CX, AX
      POP  DX
      POP  AX
      ADD  DX, BX
      ADD  DX, CX

      POP  DI
      POP  SI

      ADD  WORD [ES:DI], AX
      ADC  WORD [ES:DI+2], DX
      ADD  DI, 4

      INC  SI

      DEC  [i]
      JNZ  @BOUCLE

      POP  DS
  End;

  Inc(lu,cqr);
  Inc(vir,cqr);

 Until lu>=rcv;

 For i := 0 To gLg-1 Do
  gResult^[i] := gLev^[i] Div lu;

End;




{ Traite et reduit en 64 niveaux de gris ! }

Procedure TraiteLV( Var lv : LineVideo );
Var i : Word;
    a : Longint;
    b : Longint;
Begin
 For i := 0 To dLg-1 Do
  Begin
   a := lv[i];

   { fentre de lumire }

   a := ((a-Longint(gBLo))*255) Div gBLarge;

   If a<0 Then a := 0
   Else
    If a>255 Then a := 255;

   { distorsion }

   b := 16384-(((a*a)+16129-254*a));

   b := (b*255*Longint(gLux)) Div (100*16384);

   Inc(a,b);

   if a<0 then a := 0
   else
     if a>255 then a := 255;

{ __8C__ }

(*
   lv[i] := a Shr 2;   { rduire ! }
*)

   lv[i] := ((a*NB_GRAY) Div 256);

{ __FIN__ }

  End;
End;


Procedure LoadXLines;
Var i   : Byte;
    t   : PLineVideo;
Begin
 If gLine=0 Then { c'est le debut }
  Begin
   i := 1;
  End
 Else
  Begin
   t := dlv[1];
   dlv[1] := dlv[RDY+1];
   dlv[RDY+1] := t;
   i := 2;
  End;

 While (i<=RDY+1) Do
  Begin
   ScaleReadLV(rcv1);

   ScaleLV(gResult^,dlv[i]^,rch);

   TraiteLV(dlv[i]^);
   Inc(i);
  End;

End;



Procedure Prepare_DRCS;
Var rc  : Longint;
    rst : Longint;
    i   : Byte;
    x   : Word;
Begin
 dLg := RDX*mLg;
 dNb := RDY*mNb;

 For i := 1 To RDY+1 Do GetMem(dlv[i],SizeOf(dlv[i]^[0])*dLg);

 rch  := (gLg*65536) Div dLg;

 rcv1 := (gNb*65536) Div dNb;

End;





{ PCX => PCX }


Var fpcx     : File;
    MarkDest : MarkerRec;

Function CreatPCX : Boolean;
Var h : PCXHeadRec;
Begin
 Assign(fpcx,'PCX2VDT.TMP');
 ReWrite(fpcx,1);
 If IoResult=0 Then
  Begin
   FillChar(MarkDest,SizeOf(MarkDest),0);
   FillChar(h,SizeOf(h),0);
   BlockWrite(fpcx,h,SizeOf(h));   { creer le header (vide) }
   CreatPCX := TRUE;
   Exit;
  End
 Else Writeln('Impossible de crer un fichier temporaire!');
 CreatPCX := FALSE;
End;


Procedure CreatGrayPal( NbGray : Integer; Var p : Pal256; Maxi : Word );
Var i : Byte;
    g : Byte;
Begin
 For i := 0 To NbGray-1 Do
  Begin
   g := (i*(Maxi Div NbGray))+((((Maxi Div NbGray)-1)*i) Div (NbGray-1));
   p[i].Red   := g;
   p[i].Green := g;
   p[i].Blue  := g;
  End;
End;


Function ClosePCX : Boolean;
Var h : PCXHeadRec;
    f : File;
    e : Word;
    p : Pal256;
    i : Byte;
    g : Byte;
    sz : Longint;
    Lig : String;
Begin
 FillChar(p,SizeOf(p),0);

{ __8C__ }

 CreatGrayPal(NB_GRAY,p,256);

(*
 For i := 0 To 63 Do
  Begin
   g := i*4;
   p[i].Red   := g;
   p[i].Green := g;
   p[i].Blue  := g;
  End;
*)

{ __FIN__ }

 { ecrire palette a la fin }
 Seek(fpcx,FileSize(fpcx));
 e := $0C;
 BlockWrite(fpcx,Byte(e),1);
 BlockWrite(fpcx,p,SizeOf(p));

 FillChar(h,SizeOf(h),0);
 h.Marque  := 10;
 h.Version := 5;
 h.Codage  := 1;
 h.BPX     := 8;
 h.XG      := 0;
 h.YH      := 0;
 h.XD      := dLg-1;
 h.YB      := dNb-1;
 h.HRes    := 0;
 h.VRes    := 0;
 h.Palette := Palette16;
 h.NbPlans := 1;
 h.BPL     := dLg;

 Seek(fpcx,0);
 BlockWrite(fpcx,h,SizeOf(h));

 sz := FileSize(fpcx);

 Close(fpcx);
 e := IoResult;


 Lig := 'V.PCX';


 Assign(f,Lig);
 Erase(f);
 e := IoResult;

 Rename(fpcx,Lig);
 If IoResult<>0 Then
  Begin
   Writeln('Impossible de sauver! (voir PCX2VDT.TMP)');
   ClosePCX := FALSE;
  End
 Else
  Begin
   Writeln('Fichier PCX cr: ',Lig,'  (',sz Div 1024,' Ko)');
   ClosePCX := TRUE;
  End;
End;



Procedure FlushBufDisk;
Var r : Word;
Begin
 If MarkDest.LgBuf>0 Then
  Begin
   BlockWrite(fpcx,MarkDest.Buf,MarkDest.LgBuf,r);
   MarkDest.LgBuf := 0;
  End;
End;


Procedure WriteToDisk( b : Byte ); Assembler;
Asm
    MOV  BX, [MarkDest.LgBuf]
    MOV  AL, [b]
    MOV  [BYTE PTR MarkDest.Buf+BX], AL
    INC  [MarkDest.LgBuf]
    CMP  [MarkDest.LgBuf], TYPE MarkDest.Buf
    JB   @FIN
    CALL FlushBufDisk
@FIN:
End;


Procedure FlushRep;
Var i : Byte;
Begin
 If MarkDest.NbRep>0 Then
  Begin
   If (MarkDest.CCode And (64+128))=(64+128) Then
    Begin
     WriteToDisk(64+128+MarkDest.NbRep);
     WriteToDisk(MarkDest.CCode);
    End
   Else
    If (MarkDest.NbRep>2) Then
     Begin { coder une repetition }
      WriteToDisk(64+128+MarkDest.NbRep);
      WriteToDisk(MarkDest.CCode);
     End
    Else
     Begin
      For i := 1 To MarkDest.NbRep Do WriteToDisk(MarkDest.CCode);
     End;
   MarkDest.NbRep := 0;
  End;
End;



Procedure WriteByte( o : Byte ); Assembler;
Asm
    MOV  AH, [o]
    MOV  AL, [MarkDest.NbRep]
    OR   AL, AL
    JZ   @ZERO
    CMP  [MarkDest.CCode], AH
    JE   @ZERO_2
    CALL FlushRep
    MOV  AH, [o]
    MOV  AL, [MarkDest.NbRep]
@ZERO:
    MOV  [MarkDest.CCode], AH
@ZERO_2:
    INC  AL
    MOV  [MarkDest.NbRep], AL
    CMP  AL, 63
    JB   @FIN
    CALL FlushRep
@FIN:
End;



Procedure PutPixel( c : Byte );
Begin
 If (video_x<SizeX) And (video_y<SizeY) Then
  Begin
   ShowPixel(video_x,video_y,c And 63);
   Inc(video_x);
  End;
End;


Procedure EndPixel;
Begin
 If (video_y<SizeY) Then Inc(video_y);
 video_x := 0;
End;


Procedure WriteToPCX;
Var i : Byte;
    x : Word;
    z : PLineVideo;
Begin
 For i := 1 To RDY Do
  Begin
   z := dlv[i];
   For x := 0 To dLg-1 Do
    Begin
     WriteByte(z^[x] And 63);
    End;
   FlushRep;
  End;
End;


Type Magix = Record
       oc  : Byte;
       niv : LongInt;
      End;

     LMagix = Array[0..PPLMax-1] Of Magix;

     PLMagix = ^LMagix;

Var lm : PLMagix;

Procedure WriteToVGA;
Var i : Byte;
    x : Word;
    z : PLineVideo;
    deb : Word;
    ecart : Integer;
    u : Word;
    moy_oc : LongInt;
    moy_nb : Word;
Begin
 For i := 1 To RDY Do
  Begin
   z := dlv[i];

   For x := 0 To dLg-1 Do
    Begin
     lm^[x].oc := z^[x];
     lm^[x].niv := (z^[x]*8) Div NB_GRAY;
    End;

   deb := 0;

   For x := 1 To dLg-1 Do
    Begin
     ecart := lm^[deb].niv-lm^[x].niv;

     If (Abs(ecart)>=2) Then
      Begin
       moy_oc := 0;
       moy_nb := x-deb;
       For u := deb To x-1 Do
        Begin
         Inc(moy_oc,lm^[u].oc);
        End;

       moy_oc := moy_oc Div moy_nb;

       For u := deb To x-1 Do
        Begin
         lm^[u].oc := moy_oc;
         lm^[u].niv := (moy_oc*8) Div NB_GRAY;
        End;
       deb := x;
      End
     Else If (Abs(ecart)=1) Then deb := x;
    End;

   For x := 0 To dLg-1 Do
    Begin
     PutPixel(lm^[x].oc);
    End;
   EndPixel;
  End;
End;



Procedure FixPal( Var Pal : Pal256; nb : Integer );
Var Reg : Registers;
Begin
 Reg.AH := $10;
 Reg.AL := $12;
 Reg.BX := 0;
 Reg.CX := nb;
 Reg.ES := Seg(Pal);
 Reg.DX := Ofs(Pal);
 Intr(INTVIDEO,Reg);
End;


Procedure Prepare_Video;
Var p : Pal256;
Begin
 GetMem(lm,SizeOf(lm^[0])*dLg);

 FillChar(p,SizeOf(p),0);
 CreatGrayPal(NB_GRAY,p,64);
 FixPal(p,NB_GRAY);
 video_x := 0;
 video_y := 0;
End;


Function SauvePCX : Boolean;
Var s   : String;
    l   : Byte;
    i   : Byte;
    lig : Word;
Begin
 If CreatPCX Then
  Begin

   OpenVideo;
   Prepare_Video;

   For lig := mY To mY+(mNb-1) Do
    Begin
     LoadXLines;
     WriteToPCX;
     WriteToVGA;
     If KeyPressed Then Break;
    End;

   FlushRep;
   FlushBufDisk;

   If Not(KeyPressed) Then
    Begin
     Sound(250);
     delay(50);
     NoSound;
     While Not(KeyPressed) Do ;
     ReadKey;
    End;

   CloseVideo;

   SauvePCX := ClosePCX;

  End
 Else SauvePCX := FALSE;
End;


Begin

 NB_GRAY := 16;

 PCXName := ParamStr(1);

 mNb := 20;

 gBLo := -20;
 gBHi := 80;

 If (PCXName<>'') Then
  Begin

   If OpenHeader Then
    Begin

     ReadInit;

     Prepare_DRCS;

     Writeln('Image ''',PCXName,''' ',xMax,'x',yMax,'x',LgPal,
             ' => ',gLg,'x',gNb,' => ',dLg,'x',dNb);

     ReadStart;

     SauvePCX;

     Close(f);

    End;

  End;

End.
